import time

import discord
from discord import VoiceState
from selenium.webdriver.common.by import By

from ui_tests.src.ui_tests_shared.command_selectors_enum import CommandSelectorsEnum
from ui_tests_shared.command_test_case_with_app import CommandTestCaseWithApp
from ui_tests_shared.decorators import Async
from ui_tests_shared.ui import UI


class AFKCommandTestCase(CommandTestCaseWithApp):

    @Async.async_func
    async def test_error_message(self):
        correct_response = self._t.transform('modules.base.afk_command_channel_missing_message')
        self.assertIsNotNone(correct_response)
        self.send_command('afk', CommandSelectorsEnum.afk)

        def check(m: discord.Message):
            return m.content == correct_response and m.author.id == self._test_settings.bot_id

        response = await self._bot.wait_for('message', check=check)
        self.assertEqual(response.content, correct_response)

    @Async.async_func
    async def test_move(self):
        # correct_response = self._t.transform('modules.base.pong')
        # self.assertIsNotNone(correct_response)
        UI.driver.find_element(By.XPATH, '//*[@id="channels"]/ul/li[20]/div/div/div/a').click()
        time.sleep(1)

        self.send_command('afk', CommandSelectorsEnum.afk)

        def check(member: discord.Member, before: discord.VoiceState, after: discord.VoiceState):
            return member.id == self._bot.user.id

        response: VoiceState = await self._bot.wait_for('voice_state_update', check=check)
        self.assertIsNotNone(response.channel)
        self.assertEqual(response.channel.id, 910199452915093594)
        # self.assertEqual(response.content, correct_response)
        UI.driver.find_element(By.XPATH, '/html/body/div[1]/div[2]/div/div[1]/div/div[2]/div/div[1]/div/div/div[1]/section/div[1]/div/div[1]/div[2]/button').click()
